<?php

set_time_limit(0);

$hand = array();
$used = array();
$battlefield = array();

/*$fetches = array_fill(1, 8, 'fetch');
$basics = array_fill(9, 12, 'basic');*/
$fetches = array();
$basics = array_fill(1, 20, 'basic');
$onedrop = array_fill(21, 12, '1dropcreature');
$twodrop = array_fill(33, 12, '2dropcreature');
$threedrop = array_fill(45, 4, '3dropcreature');
$onedropspell = array_fill(49, 12, '1dropspell');

function draw()
{
	global $deck;
	global $hand;
	
	$hand[] = reset($deck);
	$temp = key($deck);
	unset($deck[$temp]);
}

function search_for_basic()
{
	global $deck;
	$found = false;
	
	$temp = reset($deck);
	do
	{
		if($temp == 'basic')
		{
			$found = true;
			$tmp = key($deck);
			unset($deck[$tmp]);
		}
		$temp = next($deck);
	}
	while(!$found);
}

$games = 50000;
$battlefield = array();
for($a = 1; $a <= $games; $a++)
{
	$handsize = 7;

	do
	{
		$hand = array();
		$deck = array_merge($fetches, $basics, $onedrop, $twodrop, $threedrop, $onedropspell);
		shuffle($deck);
		for($i = 0; $i<$handsize; $i++) draw();
		$handsize--;
		$counts = array_count_values($hand);
		$lands = 0;
		if(isset($counts['basic'])) $lands += $counts['basic'];
		if(isset($counts['fetch'])) $lands += $counts['fetch'];
	} while(($lands == 0 OR $lands > 3) AND $handsize>0);

	for($i = 1; $i <= 10; $i++)
	{
		$found = false;
		rsort($hand);
		$temp2 = reset($hand);
		if($temp2 == 'fetch')
		{
			$temp = key($hand);
			unset($hand[$temp]);
			search_for_basic();
			$found = true;
		}
		else if($temp2 == 'basic')
		{
			$temp = key($hand);
			unset($hand[$temp]);
			$found = true;
		}
	
		if($i == 1 AND $found)
		{
			$battlefield[$a][$i] = 1;
		}
		else if($i == 1)
		{
			$battlefield[$a][$i] = 0;
		}
		else if($found)
		{
			$battlefield[$a][$i] = $battlefield[$a][$i-1] + 1;
		}
		else
		{
			$battlefield[$a][$i] = $battlefield[$a][$i-1];
		}

		draw();
	}
}

$totals = array_fill(1, 10, 0);
foreach($battlefield AS $game)
{
	foreach($game AS $key => $turn)
	{
		$totals[$key] += $turn;
	}
}

foreach($totals AS $total)
{
	echo ($total / $games)."<br>";
}

?>